#!/usr/bin/perl
#
#  FILE NAME:  Contacts.cgi  Spamivore--A Spambot Food Poisoning Program
#
#  This is the main Spamivore CGI script.
#
#  The script Creates 'Bot Food (in the form of never ending e-mail lists).
#  The perfect food for any "Bad 'Bot."
#
#  INITIAL AUTHOR:  Charles V. Leonard
#
#  CHANGE HISTORY:  CVL = C. Leonard
#
# date     eng prob. / log ref. # description
# -------- --- ------------------ --------------------------------------------
# 07/16/00 CVL                    Initial creation.
#

##########################
# Global Variables       #
##########################

################################
# CONFIGURABLE VARIABLES       #
################################

$sWrkHtDocs="../www/sa";                # HTML Directory (RW-World)
$sDelHtPath="$sWrkHtDocs/";             # O/S Path name for HTML Delete
$sCgiBin="/cgi-bin";                    # CGI Bin Location
$sEmExt=".shtml";                       # SHTML Extension
$sEmRootName="saelist1_";               # Prefix name for our generated Web Page
$sLogDir="../public";                   # Directory for the Vistor Log File
$sRmList="$sLogDir/rmlist.txt";         # Name of Remove List File
$sNewRmList="$sLogDir/rmlist.tmp";      # Name of Temporary Remove List File
$sLogFile="$sLogDir/contacts.log";      # Vistor Log File
$bLogging=1;                            # 0=Visitor Logging OFF; 1=ON
$sRmLockFile="$sLogDir/RmLock.txt";     # Lock File Name
$nLockSleep=1;                          # Seconds to Sleep when lock detected.
$sPlatform="UNIX";                      # O/S Platform--"UNIX" or "WIN32"
$bDebug=0;                              # Debug Flag:  0=OFF;  1=ON.

################################
#  CONFIGURABLE VARIABLES END  #
################################

$iCnt=0;            # e-mail address creation counter
$iName=0;           # e-mail address index (to @elist1)
$nRunCount=0;       # Execution Count (successive Spambot calls to the CGI)
$nRmCount=0;        # Remove File Counter
$bRmAll=0;  # 1=Remove ALL files in Remove List file; 0=Remove All But Last File
$bNewRm=0;  # 1=New Remove File Created; 0=New Remove File Does not exist.

# Base e-Mail Generation Arrays
@elist1=("pallerd", "jar", "sandymims", "jrobberts", "rvj", "stp", "abs", "hjones", "wwguyen");
@elist2=("mindspringx.com", "earthlinky.net", "aola.com", "ix.netcomv.net", "pacificnetb.net", "hotmailt.com", "bluelightj.com", "ibm0.com");

##########################
# Global Variables End   #
##########################

#########################
# FUNCTION DEFINITIONS  #
#########################

#
#  FUNCTION NAME:  clDebug  Debug Function
#
#  Used to determine if Debug is on and if so, will print the statement
#  parameter passed to it.
#
sub clDebug

  {
    ($sStmt) = @_;

    if ($bDebug)
    {
        print $sStmt;

    } # End if Debug

  } # End of clDebug

#
#  FUNCTION NAME:  clRenameFile
#
#  Used to rename a file.
#
sub clRenameFile

  {
    #  Retrieve Parameters
    #
    #    $sObj :  Object file to rename.
    #    $sTarg:  Target file to rename the Object file as.
    #
    ($sObj, $sTarg) = @_;
    
    # Body Begin

    if ($sPlatform eq 'WIN32')
    {
        $sCmd = "rename $sObj $sTarg";
        print "<!-- \n";
        clDebug("$sCmd\n");
        # system($sCmd);
        print("qx// ", qx!$sCmd!);
        print "-->";
    }
    else
    {
        clDebug("<!-- Linking $sObj to $sTarg and deleting $sObj -->\n");
        link($sObj, $sTarg);
        unlink($sObj);
    } # end if/else 
    
  } # End of clRenameFile

# FUNCTION NAME:  clLockFile
#
# Used to "lock" the specified file.
#
sub clLockFile

  {
    # Parameters
    ($sLockFile) = @_;

    # Body Begin

    clDebug("<!-- IN clLockFile; LockFile=$sLockFile -->\n");
    while (open(LOCKIT, "< " . $sLockFile) )
    {
        close(LOCKIT);
        clDebug("<!-- UNABLE TO OBTAIN LOCK!  GOING TO SLEEP! -->\n");
        sleep($nLockSleep);  # Sleep before trying again

    } # End of while File Not Lock

    # Create the Lock File  
    if (open(LOCKIT, ">> " . $sLockFile) || die "<H3>FAILED TO CREATE LOCK FILE!</H3>.")
    {
        print LOCKIT "BY IP ADDRESS $ENV{'REMOTE_ADDR'}";
        close(LOCKIT);
    } # if We can write the lock file

  } # End of clLockFile

#
# FUNCTIOON NAME:  clUnlockFile
#
# Used to unlock the specified file.
#
sub clUnlockFile

  {
    # Parameters
    ($sLockFile) = @_;

    # Body Begin

    unlink($sLockFile);
  
  } # End of clUnlockFile

#  FUNCTION NAME:  clRmFiles
#
#  Used to find the files contained in sRmList to delete the pages that
#  are no longer being used by the Spambot.
#
sub clRmFiles

  {

    clDebug("<!-- IN clRmFiles -->\n");
    $nRmCount=0;
    if (open(RMLIST, "< " . $sRmList) || die "<H3>FAILED TO FIND DEL FILE</H3>.")
    {
        $bNewRm=0;
        if (open(NEWRMLIST, "> " . $sNewRmList) 
                || die "<H3> FAILED TO CREATE NEW RMLIST!.</H3>")
        {
            foreach $line (<RMLIST>)
            {
                if ($nRmCount > 0)
                {
                    unlink($sTargFile);
                    clDebug("<!-- REMOVING FILE $sTargFile -->\n");
                }
                ($sTargFile) = split(' ', $line);
                $nRmCount+=1;
            } # end of foreach

            if ($bRmAll)
            {
                clDebug("<!-- DELETING LAST FILE $sTargFile -->\n");
                unlink($sTargFile);
            }
            else
            {
                clDebug("<!-- CREATING NEW RMLIST -->\n");
                print NEWRMLIST "$sTargFile\n";
            }
            close(NEWRMLIST);
            $bNewRm=1;

        } # End of if open Newlist


        close(RMLIST);

        unlink($sRmList); # Delete Old Remove File List
        if ($bNewRm) # Then rename ".tmp" list as new Remove File List
        {
            clDebug("<!-- RENAMING NEW LIST -->\n");
            # link($sNewRmlist, $sRmList);
            clRenameFile($sNewRmList, $sRmList);
        }
       
    } # End if open RmList

  } # end of Function clRmFiles

#
#  FUNCTION NAME:  clAddDelFile
#
#  Used to Add an .SHTML file to the Delete File List.
#
sub clAddDelFile

  {

    $sDelFile=$sHtmlName;
    $sDelPath="$sDelHtPath$sDelFile";
    clDebug("<!-- sDelFile=$sDelFile nRunCount=$nRunCount -->\n");
    clDebug("<!-- Adding file $sDelPath! -->\n");
    clDebug("<!-- sRmList=$sRmList -->");

    clLockFile($sRmLockFile);
    if ($nRunCount > 1)
    { 
        clRmFiles;
    }

    if (open(RmList, ">> " . $sRmList) || die "<H3>FAILED TO CREATE DEL FILE</H3>.")
    {
        print RmList "$sDelPath\n";
        close(RmList);
    }
    if ($bLogging && (open(LOGFILE, ">> " . $sLogFile) || die "<H3>FAILED TO CREATE $sLogFile</H3>."))
    {
        print LOGFILE "$sDelPath $ENV{'REMOTE_ADDR'}\n";
        close(LOGFILE);
    }
    clUnlockFile($sRmLockFile);

  } # End of Function clAddDelFile

#
#  FUNCTION NAME:  clGenMailAddrs  Generate Mail Addresses Function
#
#  Used to generate the Mail Addresses that the Spambots will want to
#  gobble up.
#
sub clGenMailAddrs

  {
    # Seed the Random Generator
    srand();

    #
    #  Create e-mail lists (50 per page)
    until ($iCnt >= 50)
    {
        $iCnt += 1;
        $iNumExt = ((rand) * 100000) % 100000;
        $iName=((rand) * 10) % 9;
        $iHost=((rand) * 10) % 8;

        print "<a href=\"mailto:$elist1[$iName]$iNumExt\@$elist2[$iHost]\">$elist1[$iName]$iNumExt\@$elist2[$iHost]</a>\n";

    } # End of Until Loop

  } # End of clGenMailAddrs

#
#  FUNCTION NAME:  clCrNextTrapPage  Create the Next Trap Page Function
#
#  Used to create the next Spambot Trap Page for the Spambot to
#  unwittingly (hopefully) link to.
#
sub clCrNextTrapPage

  {

    $sHtmlName="$sEmRootName$iNumExt$sEmExt";
    $sHtmlFullName="$sWrkHtDocs/$sHtmlName";
    
    if (open(EmList, "> " . $sHtmlFullName) || die "<H3>FAILED TO CREATE HTML FILE</H3>.")
    {
        print EmList "<html>\n";
        print EmList "<HEAD>\n";
        print EmList "<TITLE>\n";
        print EmList "Sysadmin Contacts Page\n";
        print EmList "</TITLE>\n";
        print EmList "</HEAD>\n";
        print EmList "<body Background=\"wjbg001.jpg\" LINK=#00AAFF vlink=#FF7800>\n";

        print EmList "<!--#include virtual=\"$sCgiBin/Contacts.cgi?$nRunCount\"-->\n";
        print EmList "<P><a href=\"../index.shtml\">Back to Main Page!</a>\n";
        print EmList "</body>\n";
        print EmList "</html>\n";
        close(EmList);
    }

  } # End of clCrNextTrapPage

#########################
# MAIN BODY BEGIN       #
#########################

print "Content-type: text/html\n\n";

clDebug("<!-- $ARGV[0] -->\n");
clDebug("<!-- $ENV{'REMOTE_ADDR'} -->\n");

# 
# Determine the Run Count (i.e. how many times the client invokes this link/Cgi)
#
if (@ARGV)
{
       $ArgC = @ARGV;
        clDebug("<!--                  ArgC=$ArgC -->\n");
        $nRunCount=$ARGV[0];
        $nRunCount+=1;
}

# Generate the e-mail addresses.
clGenMailAddrs;

#  Create the next Trap Page for the Spambot.
clCrNextTrapPage;

#
# Create the next link for the Bad 'Bot to follow!
print "<P>";
print "<a href=\"$sHtmlName\">Rest for the Weary!</a>\n";

#  Add the file name to the "delete" list.
$bRmAll=0;  # set flag to delete all but the last HTML file
clAddDelFile;

exit(0);

#########################
# MAIN BODY END         #
#########################

############################
# END OF PROGRAM SPAMIVORE #
############################

